#Second run job
variables:
    BUILD_DOCKER_IMAGE: "lianduantraining/react-app" 
    BUILD_DOCKER_IMAGE_VERSION: "V9"
    UI_BASE_IMAGE: "node:14.17.4-stretch"
    DOCKER_CLIENT_IMAGE: "docker:20.10.16"
    DOCKER_DIND_IMAGE: "docker:20.10.16-dind"   
  # Predefined CI/CD variables, print all pipeline debug info. 
  # CI_DEBUG_TRACE: "true"
    # These can be specified per job or per pipeline
    FF_USE_FASTZIP: "true"      
    ARTIFACT_COMPRESSION_LEVEL: "fast" 
    CACHE_COMPRESSION_LEVEL: "fast" 

stages: 
   - init
   - build
   - test
   - docker image process
#   - downstream build


# Install UI Build Cache
install_ui_build_cache:
  stage: init 
  # init npm cache 
  image: "$UI_BASE_IMAGE"
  script:  
    - npm install 
  artifacts:
  #   untracked: true
      expire_in: 2 hrs
      paths:
          - node_modules/   
#  cache:
#    untracked: true  
#    key: binaries-cache-${CI_COMMIT_REF_SLUG}
#    paths:
#      - node_modules/
#    policy: pull-push     
#  tags:
#    - oracle_cloud_free_runner  

# Build UI App
ui_build:
  stage: build  
  image: "$UI_BASE_IMAGE"
  # Build React UI APP 
  script:   
    - npm run build
    # Run React Unit Test
    - npm test
  cache:
    untracked: true   
    key: binaries-cache-${CI_COMMIT_REF_SLUG}
    paths:
      - node_modules/ 
    policy: pull   
  # artifacts build result  
  artifacts:
  #   untracked: true
      expire_in: 2 hrs
      paths:
          - build/ 
#  tags:
#    - oracle_cloud_free_runner        
  
# Run React Build Test           
ui_build_test:   
  stage: test  
  image: "$UI_BASE_IMAGE"    
  script:  
     #- test -f build/index1.html   
     - test -f build/index.html     
  allow_failure: true         
## Build Docker Image and Push
docker_image_build_push:
  resource_group: $CI_JOB_NAME
  stage: docker image process
 # Variables in the .gitlab-ci.yml file
  image: "$DOCKER_CLIENT_IMAGE"  
  services:
    - "$DOCKER_DIND_IMAGE"
  before_script:
    - echo "GitLab CI/CD | Print all environment variables"
    # Print all variables
    - env
    # Project CI/CD variables, $CI_REGISTRY_USER and $CI_REGISTRY_PASSWORD
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" 
  script:  
    # Build Docker Image
    - docker build -t "$BUILD_DOCKER_IMAGE":"$BUILD_DOCKER_IMAGE_VERSION" .
    # Push Docker Image to Dock Hub
    - docker push "$BUILD_DOCKER_IMAGE":"$BUILD_DOCKER_IMAGE_VERSION"
    # ReName tag of Docker Image to latest
    - docker tag "$BUILD_DOCKER_IMAGE":"$BUILD_DOCKER_IMAGE_VERSION" "$BUILD_DOCKER_IMAGE":latest
    # Push Docker Image with latest tag to Dock Hub
    - docker push "$BUILD_DOCKER_IMAGE":latest

#downstream_build:   
#  stage: downstream build 
#  trigger:
#     project: lian.duan.training/dockerspringbootdemo
#     branch: feature-dockerspringbootdemo-v1